=head1 NAME

perlfaq - frequently asked questions about Perl ($Date: 1997/04/24 22:46:06 $)

=head1 DESCRIPTION

This document is structured into the following sections:

=over

=item perlfaq: Structural overview of the FAQ.

This document.

=item L<perlfaq1>: General Questions About Perl

Very general, high-level information about Perl.

=item L<perlfaq2>: Obtaining and Learning about Perl

Where to find source and documentation to Perl, support and training,
and related matters.

=item L<perlfaq3>: Programming Tools

Programmer tools and programming support.

=item L<perlfaq4>: Data Manipulation

Manipulating numbers, dates, strings, arrays, hashes, and
miscellaneous data issues.

=item L<perlfaq5>: Files and Formats

I/O and the "f" issues: filehandles, flushing, formats and footers.

=item L<perlfaq6>: Regexps

Pattern matching and regular expressions.

=item L<perlfaq7>: General Perl Language Issues

General Perl language issues that don't clearly fit into any of the
other sections.

=item L<perlfaq8>: System Interaction

Interprocess communication (IPC), control over the user-interface
(keyboard, screen and pointing devices).

=item L<perlfaq9>: Networking

Networking, the Internet, and a few on the web.

=back

=head2 Where to get this document

This document is posted regularly to comp.lang.perl.announce and
several other related newsgroups.  It is available in a variety of
formats from CPAN in the /CPAN/doc/FAQs/FAQ/ directory, or on the web
at http://www.perl.com/perl/faq/ .

=head2 How to contribute to this document

You may mail corrections, additions, and suggestions to
perlfaq-suggestions@perl.com .  Mail sent to the old perlfaq alias
will merely cause the FAQ to be sent to you.

=head2 What will happen if you mail your Perl programming problems to the authors

Your questions will probably go unread, unless they're suggestions of
new questions to add to the FAQ, in which case they should have gone
to the perlfaq-suggestions@perl.com instead.

You should have read section 2 of this faq.  There you would have
learned that comp.lang.perl.misc is the appropriate place to go for
free advice.  If your question is really important and you require a
prompt and correct answer, you should hire a consultant.

=head1 Credits

When I first began the Perl FAQ in the late 80s, I never realized it
would have grown to over a hundred pages, nor that Perl would ever become
so popular and widespread.  This document could not have been written
without the tremendous help provided by Larry Wall and the rest of the
Perl Porters.

=head1 Author and Copyright Information

Copyright (c) 1997 Tom Christiansen and Nathan Torkington.
All rights reserved.

=head2 Noncommercial Reproduction

Permission is granted to distribute this document, in part or in full,
via electronic means or printed copy providing that (1) that all credits
and copyright notices be retained, (2) that no charges beyond reproduction
be involved, and (3) that a reasonable attempt be made to use the most
current version available.

Furthermore, you may include this document in any distribution of the
full Perl source or binaries, in its verbatim documentation, or on a
complete dump of the CPAN archive, providing that the three stipulations
given above continue to be met.

=head2 Commercial Reproduction

Requests for all other distribution rights, including the incorporation
in part or in full of this text or its code into commercial products
such as but not limited to books, magazine articles, or CD-ROMs, must
be made to perlfaq-legal@perl.com.  Any commercial use of any portion
of this document without prior written authorization by its authors
will be subject to appropriate action.

=head2 Disclaimer

This information is offered in good faith and in the hope that it may
be of use, but is not guaranteed to be correct, up to date, or suitable
for any particular purpose whatsoever.  The authors accept no liability
in respect of this information or its use.

=head1 Changes

=over 4

=item 24/April/97

Style and whitespace changes from Chip, new question on reading one
character at a time from a terminal using POSIX from Tom.

=item 23/April/97

Added http://www.oasis.leo.org/perl/ to L<perlfaq2>.  Style fix to
L<perlfaq3>.  Added floating point precision, fixed complex number
arithmetic, cross-references, caveat for Text::Wrap, alternative
answer for initial capitalizing, fixed incorrect regexp, added example
of Tie::IxHash to L<perlfaq4>.  Added example of passing and storing
filehandles, added commify to L<perlfaq5>.  Restored variable suicide,
and added mass commenting to L<perlfaq7>.  Added Net::Telnet, fixed
backticks, added reader/writer pair to telnet question, added FindBin,
grouped module questions together in L<perlfaq8>.  Expanded caveats
for the simple URL extractor, gave LWP example, added CGI security
question, expanded on the email address answer in L<perlfaq9>.

=item 25/March/97

Added more info to the binary distribution section of L<perlfaq2>.
Added Net::Telnet to L<perlfaq6>.  Fixed typos in L<perlfaq8>.  Added
mail sending example to L<perlfaq9>.  Added Merlyn's columns to
L<perlfaq2>.

=item 18/March/97

Added the DATE to the NAME section, indicating which sections have
changed.

Mentioned SIGPIPE and L<perlipc> in the forking open answer in
L<perlfaq8>.

Fixed description of a regular expression in L<perlfaq4>.

=item 17/March/97 Version

Various typos fixed throughout.

Added new question on Perl BNF on L<perlfaq7>.

=item Initial Release: 11/March/97

This is the initial release of version 3 of the FAQ; consequently there
have been no changes since its initial release.

=back
